% Simulink 3 demonstrations and samples.
%
% Demonstration models.
%   absbrake     - ABS brake system.
%   bangbang     - State event handling demonstration.
%   bounce       - Bouncing ball using reset integrator.
%   busdemo      - Bus block.
%   clutch       - Clutch engagement model.
%   combfilter   - Data Typing with filter.
%   countersdemo - Counter demonstration.
%   datatypedemo - Data Typing demonstration.
%   enablesub    - Enabled subsysytems.
%   enabsubs     - Enabled subsystems.
%   engine       - Automotive engine model.
%   enginewc     - Automotive engine model with speed control.
%   f14          - F-14 aircraft model.
%   hardstop     - Friction model with hard stops.
%   hydcyl       - Hydraulic cylinder model.
%   hydcyl4      - Four hydraulic cylinders.
%   hydrod       - Two hydraulic cylinders inteconnected with a stiff rod.
%   mergedemo    - Merge block.
%   multi        - Multivariate lines.
%   parmest      - Parameter estimation.
%   penddemo     - Inverted pendulum (on cart) with animation.
%   pops         - Population dynamics.
%   prioritydemo - Block priority.
%   rlsest       - Adaptive control.
%   simquat      - Quaternion rotation with animation.
%   steps        - Effects of varying step size.
%   suspn        - Automotive suspension model.
%   thermo       - Thermodynamics of a house.
%   toilet       - Toilet tank flushing animation.
%   triggeredsub - Triggered subsystems.
%   vdp          - Van der Pol system of equations.
%   zeroxing     - Zero-crossing detection.
%
% Demonstration models for case studies #1,#2,#3 in the user's guide.
%   f14c       - F-14 benchmark, closed-loop form.
%   f14o       - F-14 benchmark, open-loop form.
%   f14n       - F-14 block diagram, alternate form.
%   ben2asys   - JHU/APL continuous benchmark, simple 13-state model
%   ben2bsys   - JHU/APL continuous benchmark, intermediate 42-state model.
%   ben2csys   - JHU/APL continuous benchmark, difficult 74-state model.
%   ben3asys   - JHU/APL sampled-data benchmark, simple 10-state model.
%   ben3bsys   - JHU/APL sampled-data benchmark, complex 29-state model.
%
% Demonstration scripts.
%   popdemo    - Population dynamics.
%   vdpdemo    - Van der Pol equation.
%
% Execute the MATLAB command "demo simulink" to see a menu of all demos
% and models in this directory (except for case studies #1-3).  The
% demo menu is also available by opening the Demos block in the main
% Simulink block library (which is displayed by executing "simulink").

% The routines below this line are available by typing their names
% at the MATLAB command line.
%
% Demonstration models of specialized blocks.
%   corrdemo   - Auto-correlator block.
%   fohdemo    - First order hold block.
%   lorenzs    - Lorenz attractor with X-Y scope.
%   lorenz2    - Lorenz attractor with storage scope.
%   tdeldemo   - Time delay and variable delay block.
%   logdemo    - Logic blocks.
%
% Other support routines.
%   pendan        - S-function for animation.
%   rlsppd        - rlsest discrete pole-placement utility.
%   rlspps        - rlsest continuous pole-placement utility.
%   rlsests       - rlsest S-function utility.
%   eulrot.c      - CMex S-Function for calculating Euler angles from rates.
%   eulrotdisplay - display S-Function for simquat.
%   toiletsfun    - S-function for TOILET animation.
%   toiletgui     - GUI for TOILET animation.
%
% Data files for various models and demos.
%   f14dat     - F-14 constant definitions.
%   f14def     - F-14 alternate constant definitions.
%   ben2adat   - Constant definitions for ben2asys.
%   ben2bdat   - Constant definitions for ben2bsys.
%   ben2cdat   - Constant definitions for ben2csys.
%   ben3adat   - Constant definitions for ben3asys.
%   ben3bdat   - Constant definitions for ben3bsys.
%   multidat   - Data for multi demo.

% Copyright (c) 1990-1998 by The MathWorks, Inc. All Rights Reserved.
% $Revision: 1.42 $
