function xpctrl(action)
%xpctrl	zcxnstrates basic control commands in the Control Toolbox.

%	$Revision: 1.6 $ 

if nargin<1,
    action='initialize';
end;

if strcmp(action,'initialize'),
    figNumber=figure( ...
	'Name','', ...
        'NumberTitle','off', ...
	'Visible','off');

    figDefaultAxesPos=[0.10 0.48 0.65 0.45];
    set(figNumber,'DefaultAxesPosition',figDefaultAxesPos);

    axes( ...
	'Units','normalized', ...
        'Position',figDefaultAxesPos);

    %===================================
    % Set up the MiniCommand Window
    top=0.40;
    left=0.05;
    right=0.75;
    bottom=0.02;
    labelHt=0.025;
    spacing=0.005;
    promptStr=str2mat(' ',...
              ' % ұߵİťӦ', ...
              ' % иʱڴ˴޸ĲĬRSS',...
              ' % 磬G(s)=num/den=s(s+2)/s(s+3)(s+1);numʾΪ[1 2]',...
              ' % denʾΪ[1 4 3]ݺͬơ',...
              ' % ޸ĲͼδھЧ');
    % First, the MiniCommand Window frame
    frmBorder=0.02;
    frmPos=[left-frmBorder bottom-frmBorder ...
	(right-left)+2*frmBorder (top-bottom)+2*frmBorder];
    uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
	'BackgroundColor',[0.50 0.50 0.50]);
    % Then the text label
    labelPos=[left top-labelHt (right-left) labelHt];
    uicontrol( ...
	     'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',[0.50 0.50 0.50], ...
        'ForegroundColor',[0.2 0.8 0.6], ...
        'String','');
    % Then the editable text field
    mcwPos=[left bottom (right-left) top-bottom-labelHt-spacing];
    mcwHndl=uicontrol( ...
	'Style','edit', ...
	'HorizontalAlignment','left', ...
        'Units','normalized', ...
        'Max',10, ...
	'Tag','mcw', ...
        'BackgroundColor',[1 1 1], ...
        'Position',mcwPos, ...
        'FontSize',12,...
	'Callback','xpctrl(''eval'')', ...
        'String',promptStr);

    %====================================
    % Information for all buttons
    labelColor=[0.8 0.8 0.8];
    top=0.95;
    left=0.80;
    btnWid=0.15;
    btnHt=0.08;
    % Spacing between the button and the next command's label
    spacing=0.04;

    %====================================
    % The CONSOLE frame
    frmBorder=0.02;
    yPos=0.05-frmBorder;
    frmPos=[left-frmBorder yPos btnWid+2*frmBorder 0.9+2*frmBorder];
    uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
	'BackgroundColor',[0.5 0.5 0.5]);
    
    %====================================
    % The ROOT LOCUS button
    btnNumber=1;
    yPos=top-(btnNumber-1)*(btnHt+spacing);
    labelStr='켣';
    callbackStr='xpctrl(''zcxbutton'')';
    cmdStr=str2mat( ...
       '%G(s)=1/[s(s+1)(s+2)],k=1.5,k=1.5; ng=1; dg=poly([0 -1 -2]);',...
       '%޸ʱ뽫ɾΪk=1.5; ng=1; dg=poly([0 -1 -2]);rlocus(k*ng,dg)',...
       ' sys=rss(3);', ...
       ' rlocus(sys)', ...
       ' grid on',...
       ' title(''ϵͳĸ켣'');', ...
       ' %޸ĺͼδھЧҪݺ켣ͬ'...
    );        
    
    % Generic popup button information
    btnPos=[left yPos-btnHt btnWid btnHt];
    uicontrol( ...
       'BackgroundColor',[0.50 0.50 0.50], ...
       'ForegroundColor',[0 1 0], ...
	      'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'FontSize',14,...
        'String',labelStr, ...
        'Callback',callbackStr, ...
	'UserData',cmdStr);

    %====================================
    % The BODE button
    btnNumber=2;
    yPos=top-(btnNumber-1)*(1.1*btnHt+spacing);
    labelStr='ͼ';
    callbackStr='xpctrl(''zcxbutton'')';
    cmdStr=str2mat( ...
        '%G(s)=400/[s(s+10)(s+20)],k=1.5ng=400; dg=poly([1 3 200 0]);',...
        '%޸ʱ뽫һɾΪk=1.5;ng=400; dg=poly([1 3 200 0]);',...
        ' k=1.5; ng=1; dg=poly([0 -1 -2]);',...
        ' w=logspace(-1,0.8,100);',...
        ' grid on',...
        ' bode(k*ng,dg,w);',...
        ' title(''ϵͳĲͼ'');',...
        ' %޸ĺͼδھЧҪݺͼͬ'...
     );
    
    % Generic popup button information
    btnPos=[left yPos-btnHt btnWid btnHt];
    uicontrol( ...
       'BackgroundColor',[0.50 0.50 0.50], ...
       'ForegroundColor',[0 1 0], ...
	      'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'FontSize',14,...
        'String',labelStr, ...
        'Callback',callbackStr, ...
	'UserData',cmdStr);
%==========
    btnNumber=3;
    yPos=top-(btnNumber-1)*(0.8*btnHt+spacing);
    labelStr='·ͼ';
    callbackStr='xpctrl(''zcxbutton'')';
    cmdStr=str2mat( ...
          '%紫ݺG(s)=400/[s(s+10)(s+20)],k=1.5,ng=400; dg=poly([1 3 200 0]);',...
          '%޸뽫һɾΪk=1.5;ng=400; dg=poly([1 3 200 0]);',...
          ' k=1.5; ng=1; dg=poly([0 -1 -2]);',...
          ' w=logspace(-1,1,100);',...
          ' [m,p]=bode(k*ng,dg,w);',...
          ' grid off',... 
          ' margin(m,p,w);',...
          ' title(''ϵͳĲ·ͼ'');',...
          ' %޸ĺͼδھЧݺ·ͼͬ'...
            );
    
    % Generic popup button information
    btnPos=[left yPos-btnHt btnWid btnHt];
    uicontrol( ...
       'BackgroundColor',[0.50 0.50 0.50], ...
       'ForegroundColor',[0 1 0], ...
	      'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'FontSize',12,...
        'String',labelStr, ...
        'Callback',callbackStr, ...
	'UserData',cmdStr);

%==========
    %====================================
    % The STEP RESPONSE button
    btnNumber=4;
    yPos=top-(btnNumber-1)*(0.9*btnHt+spacing);
    labelStr='Ծͼ';
    callbackStr='xpctrl(''zcxbutton'')';
    cmdStr=str2mat( ...
       '%G(s)=10/(s^2+2s+10)ĽԾͼ,num=10;den=[1 2 10];޸ʱ:',...
       '%߾ɾĳnum=10;den=[1 2 10];t=[0:.01:10];y=step(num,den,t);plot(t,y)',...
        'ng=400; dg=[1 30 200 0];',...
        'nk=[0.68 10 0]; dk=[1 0];',...
        'ngk=conv(ng,nk); dgk=conv(dg,dk); %󿪻',...
        '[ngc dgc]=cloop(ng,dg); [ngkc dgkc]=cloop(ngk,dgk);%ջ',...
        't=[0:.01:2]; y1=step(ngc,dgc,t); y2=step(ngkc,dgkc,t);',...
        'plot(t,[y1 y2])',...
        'gtext(''δ''),gtext('''');',...
        'grid on',...
        ' title(''ϵͳĽԾӦͼ'');', ...
        ' xlabel(''ʱ'');', ...
        ' %޸ĺͼδھЧҪݺԾͼͬ'...
     );        
    
  % Generic popup button information
  btnPos=[left yPos-btnHt btnWid btnHt];
  uicontrol( ...
         'BackgroundColor',[0.50 0.50 0.50], ...
       'ForegroundColor',[0 1 0], ...
	      'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'FontSize',14,...
        'String',labelStr, ...
        'Callback',callbackStr, ...
	'UserData',cmdStr);

    %====================================
    % The IMPULSE button
    btnNumber=5;
    yPos=top-(btnNumber-1)*(0.95*btnHt+spacing);
    labelStr='';
    callbackStr='xpctrl(''zcxbutton'')';
    cmdStr=str2mat( ...
        '%G(s)=10/(s^2+2s+10),num=10;den=[1 2 10];޸ʱ:',...
        '%뽫ɾΪnum=10;den=[1 2 10];t=[0:.1:10];y=impulse(num,den,t);',...
        ' sys=rss(3);', ...   
        ' [y,t]=impulse(sys);', ...
        ' plot(t,y)', ...
        ' grid on',...
        ' title(''ϵͳӦͼ'');', ...
        ' xlabel(''ʱ'');', ...
        ' %޸ĺͼδھЧҪݺԾͼͬ'...
    );        
    
    % Generic popup button information
    btnPos=[left yPos-btnHt btnWid btnHt];
    uicontrol( ...
        'BackgroundColor',[0.50 0.50 0.50], ...
       'ForegroundColor',[0 1 0], ...
        	'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'FontSize',14,...
        'String',labelStr, ...
        'Callback',callbackStr, ...
	'UserData',cmdStr);

    %====================================
    % The NYQUIST button
    btnNumber=6;
    yPos=top-(btnNumber-1)*(0.95*btnHt+spacing);
    labelStr='˹';
    callbackStr='xpctrl(''zcxbutton'')';
    cmdStr=str2mat( ...
        '%G(s)=10/(s^2+2s+10),num=10;den=[1 2 10];',...
        '% w=logspace(-1,1,100);%100ƵʵĶ',...
       '%޸ʱ뽫ɾΪnum=10;den=[1 2 10];[re,im]=nyquist(num,den,w);',...
        ' sys=rss(3);', ...   
        ' [re,im,w]=nyquist(sys);', ...
        ' plot(re(:),im(:),re(:),-im(:))', ...
        ' grid on',...
        ' title(''˹ϵͳ'');', ...
	     ' xlabel(''ʵ'');', ...
       ' ylabel('''');', ...
       ' %޸ĺͼδھЧҪݺ˹ͼͬ'...      
    );        
    
    % Generic popup button information
    btnPos=[left yPos-btnHt btnWid btnHt];
    uicontrol( ...
       'BackgroundColor',[0.50 0.50 0.50], ...
       'ForegroundColor',[0 1 0], ...
	      'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'FontSize',14,...
        'String',labelStr, ...
        'Callback',callbackStr, ...
	'UserData',cmdStr);

    %====================================
    % The CLOSE button
    uicontrol( ...
        'ForegroundColor',[0.65 0.2 0.2], ...
	     'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom btnWid btnHt], ...
        'FontSize',14,...
        'String','ر', ...
        'Callback','close(gcf)');

    % Now uncover the figure
    set(figNumber,'Visible','on');

elseif strcmp(action,'zcxbutton'),
    cmdStr=get(gco,'UserData');
    mcwHndl=findobj(gcf,'Tag','mcw');
    set(mcwHndl,'String',cmdStr);
    evalmcw(mcwHndl);

elseif strcmp(action,'eval'),
    mcwHndl=findobj(gcf,'Tag','mcw');
    cmdStr=get(mcwHndl,'String');
    evalmcw(mcwHndl);

end;    % if strcmp(action, ...
